function Figure7()
y = pickdata('BankVix');
datelab = 1989+(11/12):(1/(12)):2017+(3/12);
letters = {'(a)' '(b)' '(c)' '(d)' '(e)' '(f)'};
ynames = {'Number of Bankruptcies' 'VIX'};
subplot(1,2,1)
plot(datelab,y(:,1))
xlim(datelab([1 end]))
ylabel(ynames{1})
yyaxis right
plot(datelab,y(:,2))
ylabel(ynames{2})
yyaxis left
title(letters{1})
subplot(1,2,2)
VIX0 = y(:,1)<5;
VIX1 = y(:,1)>4 & y(:,1)<7;
VIX2 = y(:,1)>6;
dist0 = fit_ssvkernel(y(VIX0,2));
dist1 = fit_ssvkernel(y(VIX1,2));
dist2 = fit_ssvkernel(y(VIX2,2));
VIX = 0:0.1:60;
fun = @(x) x;
plot(VIX,fun(pdf(dist0,VIX)))
hold on
plot(VIX,fun(pdf(dist1,VIX)))
plot(VIX,fun(pdf(dist2,VIX)))
hold off
title(letters{2})
xlabel('VIX')
legend('B<5','4<B<7','B>6','Location','NorthEast')