function y_pred = VBDApredict(VBDAobj,h,n)
[T,r] = size(VBDAobj.y);
if r==1
    copulaPar = VBDAobj.gamma_mean;
    Param = reshape(copulaPar,length(copulaPar)/VBDAobj.p,VBDAobj.p);
    [ai,bi] = ai_bi_compute(VBDAobj.y,VBDAobj.mdist);
    U = q_u(ai,bi,VBDAobj.muz,VBDAobj.logsigmaz,VBDAobj.C,1000,VBDAobj.VA);
    u = mean(U,2);
    u_pred = zeros(h,n);
    for i = 1:n
        u_predtemp = DVine_predict(Param,h,1,VBDAobj.family,u);
        u_pred(:,i) = u_predtemp(:,end);
    end
    y_pred = ceil(icdf(VBDAobj.mdist,u_pred));
else
    if isempty(VBDAobj.C) && isempty(VBDAobj.logsigmaz)
        VBDAobj.VA = 1;
    elseif isempty(VBDAobj.C) && ~isempty(VBDAobj.logsigmaz)
        VBDAobj.VA = 2;
    elseif ~isempty(VBDAobj.C) && isempty(VBDAobj.logsigmaz)
        VBDAobj.VA = 3;
    end
    Copula_choice = VBDAobj.family;
    Param = VBDAobj.gamma_mean;
    ai = zeros(size(VBDAobj.y));
    bi = zeros(size(VBDAobj.y));
    for i = 1:r
        [ai(:,i),bi(:,i)] = ai_bi_compute(VBDAobj.y(:,i),VBDAobj.mdist{i},VBDAobj.type{i});
    end
    isDiscrete = zeros(r,1);
    for i = 1:r
        isDiscrete(i) = strcmp(VBDAobj.type{i},'discrete');
    end
    ait = ai(:,isDiscrete==1)';
    ait = ait(:);
    bit = bi(:,isDiscrete==1)';
    bit = bit(:);
    [UD,~] = q_u(ait,bit,VBDAobj.muz,VBDAobj.logsigmaz,VBDAobj.C,1000,VBDAobj.VA);
    uD = mean(UD,2);
    u = uDaibi2u(isDiscrete,ai,bi,uD);
    u_mean = reshape(u,r,T)';
    M =  calcFnu(u_mean,Param,Copula_choice);
    ind = (r*(T-VBDAobj.p)+1):(r*T); % Section of the m matrix needed to predict
    M_temp = M(ind,ind);
    u_pred = zeros(h,r,n);
    for i = 1:n
        u_pred(:,:,i) = g_u(full(M_temp),h,Param,Copula_choice);
    end
    y_pred = zeros(h,r,n);
    for  i = 1:r
        if strcmp('discrete',VBDAobj.type{i})
            y_pred(:,i,:) = ceil(icdf(VBDAobj.mdist{i},u_pred(:,i,:)));
        elseif strcmp('continous',VBDAobj.type{i}) || strcmp('continuous',VBDAobj.type{i})
            y_pred(:,i,:) = icdf(VBDAobj.mdist{i},u_pred(:,i,:));
        end
    end
end
