function [rhoSmean,rhoSquant,rhoS] = VBDAspearman_multi(VBDAobj) 
J = 2000;
[~,Gamma] = q_lambda(VBDAobj.mu,[],J,VBDAobj.family,VBDAobj.B,VBDAobj.D);
m = size(VBDAobj.y,2);
p = VBDAobj.p;
Param = Gamma2Param(Gamma,m,p);
T = p+1;
n = 10000;                                                                  %Number of paths
rhoS = zeros(m*(p+1),m,J);
family = VBDAobj.family;
margintype = VBDAobj.type;
parfor j = 1:J
    u = g_u(rand(0,0,n),T,Param(:,:,:,:,j),family);
    yy = zeros(size(u));
    for  i = 1:m
        if strcmp('discrete',margintype{i})
            yy(:,i,:) = ceil(icdf(VBDAobj.mdist{i},u(:,i,:)));
        elseif strcmp('continous',margintype{i}) || strcmp('continuous',margintype{i})
            yy(:,i,:) = icdf(VBDAobj.mdist{i},u(:,i,:));
        end
    end
    Yt1 = zeros(n,m*(p+1));
    for i = 1:size(yy,3)
        yemp = yy(:,:,i)';
        ytemp = yemp(:,end:-1:1);
        Yt1(i,:) = ytemp(:)';
    end
    rTemp = spearmanMix(Yt1,repmat(margintype,1,p+1),p);
    rhoS(:,:,j) = rTemp;
    if mod(j,100)==0
        disp(['Simulation ' mat2str(j) ' completed.'])
    end
end
rhoSmean = round(mean(rhoS,3)*1000)/1000;
rhoSquant = round(quantile(rhoS,[0.05 0.95],3)*100)/100;