function [rhoSmean,rhoSquant,rhoS] = VBDAspearman_uni(VBDAobj) 
J = 2000;
[~,G] = q_lambda(VBDAobj.mu,[],J,VBDAobj.family,VBDAobj.B,VBDAobj.D);
p = VBDAobj.p;
T = p+1;
rhoS = zeros(p,J);
dist = VBDAobj.mdist;
parfor i = 1:J
    Param = reshape(G(i,:),5,[]);
    u_pred = DVine_predict(Param,T,10000,VBDAobj.family)';
    y_pred = ceil(icdf(dist,u_pred));
    corrTemp = spearmanMix(y_pred,repmat({'D'},1,T),p);
    rhoS(:,i) = corrTemp(2:end,1);
    if mod(i,100)==0
        disp(['Simulation ' mat2str(i) ' completed.'])
    end
end
rhoSmean = mean(rhoS,2);
rhoSquant = quantile(rhoS,[0.05 0.95],2);

