function [H,LogLhat,log_theta,log_q_lambda,grad_lambda] = gradient_compute(theta,Gamma,u,z,ai,bi,family,lambda,k,VA,ct)
d = size(theta,2);       %Number of copula parameters
T = size(ai,1);
[mu,Sigma,~,~,muz,logsigmaz,C] = lambda2musigma(lambda,d,T,k,VA);
LogLhat = mix_cop_DVine_llParalel_u(Gamma,ai,bi,family,u);
S = length(LogLhat);
log_theta = logpri(theta,family);
log_q_lambda =  log_mvnpdf(theta',repmat(mu,1,S),Sigma)';
if  VA == 1
    log_q_u = repmat(sum(-log(bi-ai)),1,S);
elseif VA ==2
    Ai = repmat(ai,1,S);
    Bi = repmat(bi,1,S);
    sigmaz2 = repmat(exp(2*logsigmaz),1,S);
    muZ = repmat(muz,1,S);
    log_q_u = sum(-0.5*log(2*pi*sigmaz2)-0.5*(1./(sigmaz2)).*(z-muZ).^2-log(Bi-Ai)+0.5*log(2*pi)+0.5*z.^2);
elseif VA == 3
    Ai = repmat(ai,1,S);
    Bi = repmat(bi,1,S);
    muZ = repmat(muz,1,S);
    zMmuztC = (z-muZ)'*C;
    log_q_u = -(T/(2))*log(2*pi)+log(abs(det(C)))-0.5*sum(zMmuztC.*zMmuztC,2)'+sum(-log(Bi-Ai)+0.5*log(2*pi)+0.5*z.^2);
end
log_q_lambda = log_q_lambda + log_q_u;
grad_lambda = grad_lambda_logq(theta,z,lambda,k,T,VA);
nLambda = size(grad_lambda,1);
H = [];
if ~isempty(ct)
    H = zeros(nLambda,1);
    for i = 1:nLambda
        H(i) = mean((LogLhat+log_theta-log_q_lambda-ct(i)).*grad_lambda(i,:));
    end
end