function rs = spearmanMix(y,vartype,p)
m = size(y,2);
r = m/(p+1);
rs = zeros(m,r);
for i = 2:m
   for j = 1:min(r,i-1)
       if (strcmp(vartype{i},'C') && strcmp(vartype{j},'C')) || (strcmp(vartype{i},'continous') && strcmp(vartype{j},'continous')) || (strcmp(vartype{i},'continuous') && strcmp(vartype{j},'continuous'))
       rs(i,j) = corr(y(:,i),y(:,j),'type','Spearman');
       end
       if (strcmp(vartype{i},'D') && strcmp(vartype{j},'C')) || (strcmp(vartype{i},'discrete') && strcmp(vartype{j},'continous')) || (strcmp(vartype{i},'discrete') && strcmp(vartype{j},'continuous'))
       rs(i,j) = spearmanDC([y(:,i),y(:,j)]);
       end
       if (strcmp(vartype{i},'C') && strcmp(vartype{j},'D')) || (strcmp(vartype{i},'continous') && strcmp(vartype{j},'discrete')) || (strcmp(vartype{i},'continuous') && strcmp(vartype{j},'discrete'))
       rs(i,j) = spearmanDC([y(:,j),y(:,i)]);
       end
       if (strcmp(vartype{i},'D') && strcmp(vartype{j},'D')) || (strcmp(vartype{i},'discrete') && strcmp(vartype{j},'discrete'))
       rs(i,j) = spearmanDD([y(:,j),y(:,i)]);
       end
   end
end

for i = 1:r
    rs(i,i)=1;
end
